//////////////////////////////////////////////////////////
//// Copyrights 2008 - Rosario Azzarello /////////////////
//////////////////////////////////////////////////////////

/////////////////////////////////
//// Properties /////////////////
/////////////////////////////////

//// GAME RESET /////////////////
int gameReset = 14;  //Set the input pin for the Reset Button
int Reset = 0;  // Variable for reading the pin status of the Reset Button

//// PLAYER 1 ///////////////////
int P1_Led1 = 7;  // Set the output pin for the LED1 Player 1
int P1_Led2 = 6;  // Set the output pin for the LED2 Player 1
int P1_Led3 = 5;  // Set the output pin for the LED3 Player 1
int P1_Tor = 11;  // Set the input pin for the Tor Player 1
int P1_Goals = 0;  // variable for reading how many goals made the player 1
int P1_Val = 0;  // variable for reading the pin status of the player 1

//// PLAYER 2 ///////////////////
int P2_Led1 = 4;  // Set the output pin for the LED1 Player 2
int P2_Led2 = 3;  // Set the output pin for the LED2 Player 2
int P2_Led3 = 1;  // Set the output pin for the LED3 Player 2
int P2_Tor = 12;  // Set the input pin for the Tor of Player 2
int P2_Goals = 0;  // variable for reading how many goals made the player 2
int P2_Val = 0;  // variable for reading the pin status of the player 2

//// LED DANCE ///////////////////
int led_Timer = 100;  // The higher the number, the slower the timing.
int P1_Led_Pins[] = { 7, 6, 5 };  // an array of pin numbers
int P2_Led_Pins[] = { 4, 3, 1 };  // an array of pin numbers
int led_Number = 3;  // the number of pins (i.e. the length of the array)
int blink_Timer = 100;

//// GOAL DELAY //////////////////
int goal_Delay = 5000;

//// BUZZER /////////////////////
int buzzer = 0; //Set the input pin for the Reset Button

/////////////////////////////////
//// Constructor ////////////////
/////////////////////////////////

void setup() {
  
  pinMode(gameReset, INPUT);  //Set the input pin for the Reset Button to INPUT
  
  pinMode(P1_Led1, OUTPUT);  //Set the output pin for the LED1 of Player 1 to OUTPUT
  pinMode(P1_Led2, OUTPUT);  //Set the output pin for the LED2 of Player 1 to OUTPUT
  pinMode(P1_Led3, OUTPUT);  //Set the output pin for the LED3 of Player 1 to OUTPUT
  pinMode(P1_Tor, INPUT);  //Set the input pin for the Tor of Player 1 to INPUT
  
  pinMode(P2_Led1, OUTPUT);  //Set the output pin for the LED1 of Player 2 to OUTPUT
  pinMode(P2_Led2, OUTPUT);  //Set the output pin for the LED2 of Player 2 to OUTPUT
  pinMode(P2_Led3, OUTPUT);  //Set the output pin for the LED3 of Player 2 to OUTPUT
  pinMode(P2_Tor, INPUT);  //Set the input pin for the Tor of Player 2 to INPUT
  
  int P1_i;
  int P2_i;
  pinMode(P1_Led_Pins[P1_i], OUTPUT);
  pinMode(P2_Led_Pins[P2_i], OUTPUT);
  
  pinMode(buzzer, OUTPUT);  //Set the output pin for the buzzer to OUTPUT
}

/////////////////////////////////
//// Methods ////////////////////
/////////////////////////////////

void loop(){

  //// GAME RESET ///////////////////
  Reset = digitalRead(gameReset);
  if (Reset == LOW) {
    P1_Goals = 0;
    P2_Goals = 0;
    
    digitalWrite(P1_Led1, LOW);
    digitalWrite(P1_Led2, LOW);
    digitalWrite(P1_Led3, LOW);
    
    digitalWrite(P2_Led1, LOW);
    digitalWrite(P2_Led2, LOW);
    digitalWrite(P2_Led3, LOW);
  }
  
  //// PLAYER 1 ///////////////////
  P1_Val = digitalRead(P1_Tor);
  if (P1_Val == LOW) {
    
    if (P1_Goals == 0) {
      digitalWrite(P1_Led1, HIGH);  // Player 1 made 1 goal
      goalMelody();
    }
    if (P1_Goals == 1) {
      digitalWrite(P1_Led2, HIGH);  // Player 1 made 2 goal
      goalMelody();
    }
    if (P1_Goals == 2) {
      digitalWrite(P1_Led3, HIGH);  // Player 1 made 3 goal
      victoryMelody();
      
      //// BLINK FOR A WHILE ///////////////////
      int i;
      
      for (i = 0; i < blink_Timer; i++) {
        int P1_i;
        
        for (P1_i = 0; P1_i < led_Number; P1_i++) {
          digitalWrite(P1_Led_Pins[P1_i], HIGH);
          delay(led_Timer);
          digitalWrite(P1_Led_Pins[P1_i], LOW);
        }
        
        for (P1_i = led_Number - 1; P1_i >= 0; P1_i--) {
          digitalWrite(P1_Led_Pins[P1_i], HIGH);
          delay(led_Timer);
          digitalWrite(P1_Led_Pins[P1_i], LOW);
        }
        
      }
    }
    
    delay(goal_Delay);
    P1_Goals++;
  }
  
  //// PLAYER 2 ///////////////////
  P2_Val = digitalRead(P2_Tor);
  if (P2_Val == LOW) {
    
    if (P2_Goals == 0) {
      digitalWrite(P2_Led1, HIGH);  // Player 2 made 1 goal
      goalMelody();
    }
    if (P2_Goals == 1) {
      digitalWrite(P2_Led2, HIGH);  // Player 2 made 2 goal
      goalMelody();
    }
    if (P2_Goals == 2) {
      digitalWrite(P2_Led3, HIGH);  // Player 2 made 3 goal
      victoryMelody();
      
      //// BLINK FOR A WHILE ///////////////////
      int i;
      
      for (i = 0; i < blink_Timer; i++) {
        int P2_i;
        
        for (P2_i = 0; P2_i < led_Number; P2_i++) {
          digitalWrite(P2_Led_Pins[P2_i], HIGH);
          delay(led_Timer);
          digitalWrite(P2_Led_Pins[P2_i], LOW);
        }
        
        for (P2_i = led_Number - 1; P2_i >= 0; P2_i--) {
          digitalWrite(P2_Led_Pins[P2_i], HIGH);
          delay(led_Timer);
          digitalWrite(P2_Led_Pins[P2_i], LOW);
        }
      }
    }
    
    delay(goal_Delay);
    P2_Goals++;
  }
}

//// BUZZ THE GOAL MELODY ///////////////////
void goalMelody(){
  //Part 1
  digitalWrite(buzzer, HIGH);
  delay(200);
  digitalWrite(buzzer, LOW);
  delay(100);
  digitalWrite(buzzer, HIGH);
  delay(200);
  digitalWrite(buzzer, LOW);
  delay(100);
  digitalWrite(buzzer, HIGH);
  delay(90);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(90);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(110);
  digitalWrite(buzzer, LOW);
  delay(200);
  
  //Part 2
  digitalWrite(buzzer, HIGH);
  delay(70);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(90);
  digitalWrite(buzzer, LOW);
  delay(90);
  digitalWrite(buzzer, HIGH);
  delay(70);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(90);
  digitalWrite(buzzer, LOW);
  delay(200);
  
  //Part 3
  digitalWrite(buzzer, HIGH);
  delay(70);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(90);
  digitalWrite(buzzer, LOW);
}

//// BUZZ THE VICTORY MELODY ///////////////////
void victoryMelody(){
  digitalWrite(buzzer, HIGH);
  delay(600);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(600);
  digitalWrite(buzzer, LOW);
  delay(70);
  digitalWrite(buzzer, HIGH);
  delay(1000);
  digitalWrite(buzzer, LOW);
}
